
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 blue
//---- input parameters
extern int       Length=4;
extern int       Shift=1;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double SumX = Length *(Length - 1)*0.5 + Length;
   double SumX2 = Length *(Length -1) * (2*Length - 1)/6 + Length * Length;
   double SumY;
   double SumXY;
   double Xbar = SumX / Length;
   double Ybar;
   double b;
   int chart_bar_idx, lr_bar_idx;
   
   //loop over every uncalculated bar in the chart
   for (chart_bar_idx = 0; chart_bar_idx < (Bars - counted_bars); chart_bar_idx++)
   {
      if (chart_bar_idx + Length > Bars) break; //protect against buffer overrrun
      
      if (chart_bar_idx > 0)
      {
         SumY = Close[chart_bar_idx];   
         SumXY = Close[chart_bar_idx] * Length;
      }
      else
      {
         SumY = Ask;   
         SumXY = Ask * Length;
      }
      
      //for each uncalulated bar in the chart loop over Length previous close prices
      for(lr_bar_idx = chart_bar_idx + 1; lr_bar_idx < chart_bar_idx + Length; lr_bar_idx++)
      {
         SumY += Close[lr_bar_idx];
         SumXY += Close[lr_bar_idx] * (Length - (lr_bar_idx - chart_bar_idx));
      }
      Ybar = SumY / Length;
      b = (Length * SumXY - SumX * SumY) / (Length * SumX2 - SumX * SumX);
      if (chart_bar_idx - Shift >= 0) ExtMapBuffer1[chart_bar_idx - Shift] = Ybar - b*Xbar + b*(Length + 1);
   }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+